import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:geideadesignframework/GeideaColors.dart';
import 'package:geideadesignframework/style_config.dart';

class GeideaToggleButtons extends StatefulWidget {
  GeideaToggleButtons(
      {Key key,
      @required this.items,
      this.borderColor,
      this.backgroundColor,
      this.fontColor,
      this.selectedFontColor,
      this.fontSize,
      this.textAlign,
      this.paddingVertical,
      this.paddingHorizontal,
      this.borderRadius,
        this.buttonWidth,
      this.borderWidth})
      : super(key: key);

  final items;
  final Color borderColor;
  final Color backgroundColor;
  final Color fontColor;
  final Color selectedFontColor;
  final double fontSize;
  final double paddingVertical;
  final double paddingHorizontal;
  final TextAlign textAlign;
  final double borderRadius;
  final double borderWidth;
  final double buttonWidth;

  @override
  _GeideaToggleButtonsState createState() => _GeideaToggleButtonsState();
}

class _GeideaToggleButtonsState extends State<GeideaToggleButtons> {
//  List<bool> isSelected = [];
//  List<Widget> children = <Widget>[];
  List<bool> checkValues;

  @override
  void initState() {
    super.initState();
    checkValues = List.generate(
        widget.items.length, (index) => widget.items[index]['checked']);
  }

  @override
  Widget build(BuildContext context) {
    final children = widget.items
        .map<Widget>((value) => Container(
              width: widget.buttonWidth ?? 130,
              child: Center( child: Text(
                value['text'],
                style: TextStyle(
                  fontSize: widget.fontSize ?? styleConfig.mainFontSize,
                  fontFamily: styleConfig.fontFamily ?? styleConfig.fontFamily,
                ),
              ),
            )))
        .toList();
    return Center(
        child: ToggleButtons(
      borderColor: widget.borderColor ?? styleConfig.theme.primaryColor,
      fillColor: widget.backgroundColor ?? styleConfig.theme.primaryColor,
      borderWidth: widget.borderWidth ?? styleConfig.borderWidth,
      selectedBorderColor:
          widget.backgroundColor ?? styleConfig.theme.primaryColor,
      selectedColor: widget.selectedFontColor ?? styleConfig.theme.canvasColor,
      borderRadius: BorderRadius.circular(
          widget.borderRadius ?? styleConfig.borderRadius),
      children: children,
      isSelected: checkValues,
      onPressed: (int index) {
        if (widget.items[index]['onTap'] != null) {
          widget.items[index]['onTap']();
        }
        setState(() {
          checkValues = List.generate(widget.items.length, (index) => false);
          checkValues[index] = !checkValues[index];
        });
      },
    ));
  }
}
